/*
 * MPU_6050_Test.c
 *
 * Created: 05.11.2014 14:52:43
 *  Author: Marcel
 */

#define F_CPU 12000000UL

#include <avr/io.h>
#include <avr/interrupt.h>
#include <math.h>
#include "MPU6050.h"
#include "i2c_master.h"
#include "LCD_4.h"

int count = 0;

int accelX = 0;
int accelY = 0;

double realx = 0;
double realy = 0;
double realz = 0;

void init(){
	
	lcd_init();
	
	i2c_init();
	
	init_MPU6050();
	
	//Calibrate_Gyro();
	
	DDRC |= 0xF0;
	PORTC |= 0b01000000;
	
	TCCR2 = 0b00000010;
	TIMSK = 0b01000000;
	sei();
}

int main(void)
{
	init();
	
    while(1)
    {
        lcd_pos(0,0);
		printf("X:%5d", realx);
		
		lcd_pos(1,0);
		printf("Y:%5d", realy);
    }
}

ISR(TIMER2_OVF_vect){
	
	if (count >= 59){ // 100Hz --> 59 50Hz --> 118
		
		ReadDataAccel();
		ReadDataGyro();
		
		accelX = atan2(-GetAccelY(), GetAccelZ()) * 180.0 / M_PI;
		accelY= atan2(-GetAccelX(), GetAccelZ()) * 180.0 / M_PI;
		
		realx += GetGyroX() / 1640.0;
		realy += GetGyroY() / 1640.0;
		realz += GetGyroZ() / 1640.0;
		
		//realx = realx * 0.98 + accelX * 0.02;
		//realy = realy * 0.98 + accelY * 0.02;

		count = 0;
	}
	
	count++;
}